Torque2D Reference

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | List of all members
b2ContactListener Class Reference

`#include <b2WorldCallbacks.h>`

Inheritance diagram for b2ContactListener:

## Public Member Functions
virtual | ~b2ContactListener ()
virtual void | BeginContact (b2Contact *contact)
| Called when two fixtures begin to touch. More...
virtual void | EndContact (b2Contact *contact)
| Called when two fixtures cease to touch. More...
virtual void | PreSolve (b2Contact *contact, const b2Manifold *oldManifold)
virtual void | PostSolve (b2Contact *contact, const b2ContactImpulse *impulse)

## Detailed Description

Implement this class to get contact information. You can use these results for things like sounds and game logic. You can also get contact results by traversing the contact lists after the time step. However, you might miss some contacts because continuous physics leads to sub-stepping. Additionally you may receive multiple callbacks for the same contact in a single time step. You should strive to make your callbacks efficient because there may be many callbacks per time step.

Warning
  You cannot create/destroy Box2D entities inside these callbacks.

## Constructor & Destructor Documentation

virtual ~b2ContactListener | ( |  | ) |
| inline virtual

## Member Function Documentation

virtual void BeginContact | ( | b2Contact * | contact | ) |
| inline virtual

Called when two fixtures begin to touch.

Reimplemented in Scene.

virtual void EndContact | ( | b2Contact * | contact | ) |
| inline virtual

Called when two fixtures cease to touch.

Reimplemented in Scene.

virtual void PostSolve | ( | b2Contact * | contact,
|  | const b2ContactImpulse * | impulse
| ) |  |
| inline virtual

This lets you inspect a contact after the solver is finished. This is useful for inspecting impulses. Note: the contact manifold does not include time of impact impulses, which can be arbitrarily large if the sub-step is small. Hence the impulse is provided explicitly in a separate data structure. Note: this is only called for contacts that are touching, solid, and awake.

Reimplemented in Scene.

virtual void PreSolve | ( | b2Contact * | contact,
|  | const b2Manifold * | oldManifold
| ) |  |
| inline virtual

This is called after a contact is updated. This allows you to inspect a contact before it goes to the solver. If you are careful, you can modify the contact manifold (e.g. disable contact). A copy of the old manifold is provided so that you can detect changes. Note: this is called only for awake bodies. Note: this is called even when the number of contact points is zero. Note: this is not called for sensors. Note: if you set the number of contact points to zero, you will not get an EndContact callback. However, you may get a BeginContact callback the next step.

Reimplemented in Scene.

The documentation for this class was generated from the following file:

- Box2D/Dynamics/b2WorldCallbacks.h